/*
 * Copyright (C) 2020, Inria
 * GRAPHDECO research group, https://team.inria.fr/graphdeco
 * All rights reserved.
 *
 * This software is free for non-commercial, research and evaluation use 
 * under the terms of the LICENSE.md file.
 *
 * For inquiries contact sibr@inria.fr and/or George.Drettakis@inria.fr
 */


#ifndef __SIBR_ULR_REPETITIONS_RENDERER_HPP__
# define __SIBR_ULR_REPETITIONS_RENDERER_HPP__

# include <projects/facade_repetitions/renderer/Config.hpp>
# include <core/system/Config.hpp>
# include <core/graphics/Texture.hpp>
# include <core/graphics/Shader.hpp>
# include <core/graphics/Mesh.hpp>
# include <core/renderer/RenderMaskHolder.hpp>

namespace sibr
{
	/**
	 * Render a facade as generated by the Exploiting Repetitions for Image-Based Rendering of Facades pipeline.
	 * Modified version of our ULR implementation for the based rendering.
	 */
	class SIBR_FACADE_REPETITIONS_EXPORT ULRRepetitionsRenderer : public RenderMaskHolder
	{
	SIBR_CLASS_PTR(ULRRepetitionsRenderer);

		/**
		 * Renderer constructor.
		 * \param ibrScene The IBR scene containing the facade.
		 * \param maxCams The maximum number of cameras to use for rendering a frame.
		 * \param altShader Override the ULR shader used.
		 */
		ULRRepetitionsRenderer(const BasicIBRScene::Ptr& ibrScene, unsigned int maxCams = 0,
			const std::string& altShader = "ulr_v2_array");

		/**
		 * \brief Render the scene.
		 * \param imgs_ulr Indices of the images and cameras to use for rendering the frame.
		 * \param lastFullCamid The highest index of the initial input images (refer to the paper).
		 * \param eye The current camera.
		 * \param scene The current IBR scene.
		 * \param altMesh An optional mesh to override the scene mesh.
		 * \param inputImages An OpenGL texture 2D array containing the input images.
		 * \param inputDepths  An OpenGL texture 2D array containing the depth renders of the scene from the input cameras.
		 * \param dst The render target to render to.
		 */
		void process(std::vector<uint>& imgs_ulr, int lastFullCamid,
		             const Camera& eye,
		             const BasicIBRScene& scene,
		             Mesh::Ptr altMesh,
		             const std::shared_ptr<ITexture2DArray>& inputImages,
		             const std::shared_ptr<ITexture2DArray>& inputDepths,
		             /*const std::shared_ptr<ITexture2DArray>& inputMasks,*/
		             IRenderTarget& dst);

		/**
		 * \brief (inherited from ULRv2)
		 * \param val The occlusion parameter.
		 */
		void doOccl(bool val) { _doOccl = val; }
		/**
		 * \brief (inherited from ULRv2)
		 * \param val The binary masks parameter.
		 */
		void setAreMasksBinary(bool val) { _areMasksBinary = val; }

		/**
		 * \brief (inherited from ULRv2)
		 * \param val The inverted masks parameter.
		 */
		void setDoInvertMasks(bool val) { _doInvertMasks = val; }
		
		/**
		 * \brief (inherited from ULRv2)
		 * \param val The parameter for discarding black pixels.
		 */
		void setDiscardBlackPixels(bool val) { _discardBlackPixels = val; }

		/**
		 * \brief Get the number of cameras used.
		 * \return The number of cameras used.
		 */
		size_t getNumCams() { return _numCams; }

	private:

		RenderTargetRGBA32F::Ptr _depthRT;

		GLShader _depthShader;
		GLParameter _proj;

		GLShader _ulrShader;
		std::vector<GLParameter> _icamProj;
		std::vector<GLParameter> _icamPos;
		std::vector<GLParameter> _icamDir;
		GLParameter _camCount;
		GLParameter _lastFullCamId;
		std::vector<GLParameter> _icamIds;
		GLParameter _ncamPos;

		GLParameter _occTest;
		GLParameter _areMasksBinaryGL;
		GLParameter _doInvertMasksGL;
		GLParameter _discardBlackPixelsGL;
		GLParameter _doMask;

		bool _doOccl;
		bool _areMasksBinary;
		bool _doInvertMasks;
		bool _discardBlackPixels;
		size_t _numCams;
	};
} /*namespace sibr*/
#endif /* define */
